/////////////////////////////////////////////////////////////////////////////
//		DlgProc.c
#include	<windows.h>
#include	"util.h"
#include	"ExArc.h"
#include	"resource.h"


/////////////////////////////////////////////////////////
//	錾

//ϐ
TCHAR	m_szIcon[MAX_PATH];		//ACR
int		m_nIcon;

extern	HANDLE	m_hDLL[ID_DLL_MAX];			//DLL̃nh


/////////////////////////////////////////////////////////
//	֐

#define	EnableDlgItem(dlg,id,cmd)	EnableWindow(GetDlgItem(dlg,id),cmd)
#define	IsDlgItemEnabled(dlg,id)	IsWindowEnabled(GetDlgItem(dlg,id))
#define	SetDlgItemCheck(dlg,id,chk)	SendDlgItemMessage(dlg,id,BM_SETCHECK,chk,0)
#define	GetDlgItemCheck(dlg,id)		SendDlgItemMessage(dlg,id,BM_GETCHECK,0,0)

UINT	GetExtType( LPCTSTR szExt )
{
	TCHAR	szBuf[MAX_PATH];
	HKEY	hKey;
	UINT	nResult=0;

	hKey = RegKeyOpen( HKEY_CLASSES_ROOT, szExt );
	if( hKey )
	{
		RegGetString( hKey, NULL, szBuf, MAX_PATH );
		if( !lstrcmp( szBuf, _T("ExArc") ) )
			nResult = 1;
		RegKeyClose( hKey );
	}
	return	nResult;
}

VOID	SetExtType( LPCTSTR szExt, BOOL bCheck )
{
	HKEY	hKey;

	if( bCheck )
	{
		if( hKey = RegKeyCreate(HKEY_CLASSES_ROOT,szExt) )
		{
			RegSetString( hKey, NULL, _T("ExArc") );
			RegKeyClose( hKey );
		}
	}
	else
	{
		RegKeyForceDelete( HKEY_CLASSES_ROOT, szExt );
	}
}


/////////////////////////////////////////////////////////
//	֐

//
BOOL	OnInitDialog( HWND hDlg )
{
	TCHAR	szBuf[MAX_PATH];
	HKEY	hKey, hKeyIcon;
	HICON	hIcon;

	//gq
	SetDlgItemCheck( hDlg, IDC_CHKCAB, GetExtType(_T(".cab")) );
	SetDlgItemCheck( hDlg, IDC_CHK7Z , GetExtType(_T(".7z" )) );
	SetDlgItemCheck( hDlg, IDC_CHKZIP, GetExtType(_T(".zip")) );
	SetDlgItemCheck( hDlg, IDC_CHKLHA, GetExtType(_T(".lzh")) );
	SetDlgItemCheck( hDlg, IDC_CHKRAR, GetExtType(_T(".rar")) );
	SetDlgItemCheck( hDlg, IDC_CHKTAR, GetExtType(_T(".tgz")) );

	EnableDlgItem( hDlg, IDC_CHKCAB, (BOOL)m_hDLL[ID_DLL_CAB  ] );
	EnableDlgItem( hDlg, IDC_CHK7Z , (BOOL)m_hDLL[ID_DLL_7ZIP ] );
	EnableDlgItem( hDlg, IDC_CHKZIP, (BOOL)m_hDLL[ID_DLL_7ZIP ] || m_hDLL[ID_DLL_UNZIP] );
	EnableDlgItem( hDlg, IDC_CHKLHA, (BOOL)m_hDLL[ID_DLL_UNLHA] );
	EnableDlgItem( hDlg, IDC_CHKRAR, (BOOL)m_hDLL[ID_DLL_UNRAR] );
	EnableDlgItem( hDlg, IDC_CHKTAR, (BOOL)m_hDLL[ID_DLL_TAR  ] );

	//ڍ
	if( hKey = RegKeyOpen( HKEY_CLASSES_ROOT, _T("ExArc") ) )
	{
		RegGetString( hKey, NULL, szBuf, MAX_PATH );
		SetDlgItemText( hDlg, IDC_TXTTYPE, szBuf );
		if( hKeyIcon = RegKeyOpen(hKey,_T("DefaultIcon")) )
		{
			LPTSTR p;
			RegGetString( hKeyIcon, NULL, szBuf, MAX_PATH );
			lstrcpy( m_szIcon, szBuf );
			p = lstrrchr( m_szIcon, ',' );
			if(p)	m_nIcon=lston(p+1), *p=0;
			else	m_nIcon=0;

			RegKeyClose( hKeyIcon );
		}
		RegKeyClose( hKey );
	}
	else
	{
		SetDlgItemText( hDlg, IDC_TXTTYPE, _T("Ƀt@C") );
		GetModuleFileName( NULL, m_szIcon, MAX_PATH );
		m_nIcon = 1;
	}

	hIcon = ExtractIcon( NULL, m_szIcon, m_nIcon );
	SendDlgItemMessage( hDlg, IDC_ICOTYPE, STM_SETICON, (WPARAM)hIcon, 0 );
	SendMessage( hDlg, WM_COMMAND, IDC_CHKLHA, 0 );

	return	TRUE;
}

//OK{^
BOOL	OnBtnOK( HWND hDlg )
{
	TCHAR	szBuff[MAX_PATH];
	HKEY	hKey;

	//gq
	SetExtType( _T(".cab"), GetDlgItemCheck(hDlg,IDC_CHKCAB) );
	SetExtType( _T(".7z" ), GetDlgItemCheck(hDlg,IDC_CHK7Z ) );
	SetExtType( _T(".zip"), GetDlgItemCheck(hDlg,IDC_CHKZIP) );
	SetExtType( _T(".lzh"), GetDlgItemCheck(hDlg,IDC_CHKLHA) );
	SetExtType( _T(".rar"), GetDlgItemCheck(hDlg,IDC_CHKRAR) );
	SetExtType( _T(".tar"), GetDlgItemCheck(hDlg,IDC_CHKTAR) );
	SetExtType( _T(".z"  ), GetDlgItemCheck(hDlg,IDC_CHKTAR) );
	SetExtType( _T(".gz" ), GetDlgItemCheck(hDlg,IDC_CHKTAR) );
	SetExtType( _T(".bz2"), GetDlgItemCheck(hDlg,IDC_CHKTAR) );
	SetExtType( _T(".taz"), GetDlgItemCheck(hDlg,IDC_CHKTAR) );
	SetExtType( _T(".tgz"), GetDlgItemCheck(hDlg,IDC_CHKTAR) );
	SetExtType( _T(".tbz"), GetDlgItemCheck(hDlg,IDC_CHKTAR) );

	//ڍ
	if( IsDlgItemEnabled(hDlg,IDC_BTNTYPE) )
	{
		if( hKey=RegKeyCreate(HKEY_CLASSES_ROOT,_T("ExArc")) )
		{
			GetDlgItemText( hDlg, IDC_TXTTYPE, szBuff, MAX_PATH );
			RegSetString( hKey, NULL, szBuff );
			RegKeyClose( hKey );
		}
		if( hKey=RegKeyCreate(HKEY_CLASSES_ROOT,_T("ExArc\\DefaultIcon")) )
		{
			wsprintf( szBuff, _T("%s,%d"), m_szIcon, m_nIcon );
			RegSetString( hKey, NULL, szBuff );
			RegKeyClose( hKey );
		}
		if( hKey=RegKeyCreate(HKEY_CLASSES_ROOT,_T("ExArc\\Shell\\Open")) )
		{
//			RegSetString( hKey, NULL, _T("WJ(&E)") );
			RegKeyClose( hKey );
		}
		if( hKey=RegKeyCreate(HKEY_CLASSES_ROOT,_T("ExArc\\Shell\\Open\\Command")) )
		{
			GetModuleFileName( NULL, szBuff, MAX_PATH );
			lstrcat( szBuff, _T(" \"%1\"") );
			RegSetString( hKey, NULL, szBuff );
			RegKeyClose( hKey );
		}
	}
	else
	{
		RegKeyForceDelete( HKEY_CLASSES_ROOT, _T("ExArc") );
	}

	DestroyWindow( hDlg );
	return	TRUE;
}

//ݾ {^
BOOL	OnBtnCancel( HWND hDlg )
{
	DestroyWindow( hDlg );
	return	TRUE;
}

//gq̃`FbN
BOOL	OnChkExt( HWND hDlg )
{
	BOOL bEnable =	GetDlgItemCheck( hDlg, IDC_CHKCAB ) ||
					GetDlgItemCheck( hDlg, IDC_CHK7Z  ) ||
					GetDlgItemCheck( hDlg, IDC_CHKZIP ) ||
					GetDlgItemCheck( hDlg, IDC_CHKLHA ) ||
					GetDlgItemCheck( hDlg, IDC_CHKRAR ) ||
					GetDlgItemCheck( hDlg, IDC_CHKTAR );
	EnableDlgItem( hDlg, IDC_BTNTYPE, bEnable );
	EnableDlgItem( hDlg, IDC_TXTTYPE, bEnable );

	return	TRUE;
}

//ACR̕ύX
BOOL	OnBtnType( HWND hDlg )
{
	HICON	hIcon;

	if( IconDialogBox( m_szIcon, &m_nIcon ) )
	{
		hIcon = ExtractIcon( NULL, m_szIcon, m_nIcon );
		SendDlgItemMessage( hDlg, IDC_ICOTYPE, STM_SETICON, (WPARAM)hIcon, 0 );
	}
	return	TRUE;
}

//vV[W
BOOL WINAPI	DialogProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	static HWND	hIDOK;

	switch( uMsg )
	{
	case WM_INITDIALOG:
		return	OnInitDialog( hDlg );

	case WM_COMMAND:
		switch( wParam )
		{
		case IDC_CHKCAB:	case IDC_CHK7Z:		case IDC_CHKZIP:
		case IDC_CHKLHA:	case IDC_CHKRAR:	case IDC_CHKTAR:
			return	OnChkExt( hDlg );

		case IDC_BTNTYPE:
			return	OnBtnType( hDlg );

		case IDOK:
			return	OnBtnOK( hDlg );

		case IDCANCEL:
			return	OnBtnCancel( hDlg );
		}
		break;

	case WM_CLOSE:
		DestroyWindow( hDlg );
		break;

	case WM_DESTROY:
		PostQuitMessage(0);
		break;

	default:
		return	DefWindowProc(hDlg,uMsg,wParam,lParam);
	}
	return	FALSE;
}
