/////////////////////////////////////////////////////////////////////////////
//		ExArc.c
#include	<windows.h>
#include	"util.h"
#include	"ExArc.h"
#include	"resource.h"


/////////////////////////////////////////////////////////
//	֐

//Ƀt@C̉
void ExtractFile( LPTSTR szFile )
{
	ID_ARC			idArc;
	TCHAR			*p, szPath[MAX_PATH];
	WIN32_FIND_DATA	ffd;

	//t@C̎擾
	FindFirstFile( szFile, &ffd );
	p = lstrrchr( ffd.cFileName, '.' );
	if( p )		*p = 0;

	//𓀂tH_
	lstrcpy( szPath, szFile );
	p = lstrrchr( szPath, '\\' );
	if( p )		lstrcpy( p+1, ffd.cFileName );
	else		lstrcpy( szPath, ffd.cFileName );
	lstrcat( szPath, _T("\\") );

	//
	idArc = ArcCheckFileType( szFile );
	if( idArc != ID_ARC_NOT )
	{
		CreateDirectory( szPath, NULL );
		ArcExtractArchive( idArc, szFile, szPath );
	}
}

//_CAO̕\
UINT OptionDialog( HINSTANCE hInst, int nCmdShow )
{
	HWND		hDlg;
	MSG			msg;
	WNDCLASS	wc;

	//EBhENX̓o^
	ZeroMemory( &wc, sizeof(wc) );
	wc.lpfnWndProc   = DialogProc;
	wc.cbWndExtra    = DLGWINDOWEXTRA;
	wc.hInstance     = hInst;
	wc.hIcon         = LoadIcon( hInst, MAKEINTRESOURCE(IDI_ICONMAIN) );
	wc.hCursor       = LoadCursor( NULL, IDC_ARROW );
	wc.hbrBackground = (HBRUSH)(COLOR_BTNFACE+1);
	wc.lpszClassName = OPTIONCLASS;
	if( RegisterClass(&wc) == 0 )
		return	FALSE;

	//_CAO̍쐬
	hDlg = CreateDialog( hInst, MAKEINTRESOURCE(IDD_DLGOPTION), 0, DialogProc );
	if( hDlg == NULL )
		return	FALSE;

	//\
	ShowWindow( hDlg, nCmdShow );
	UpdateWindow( hDlg );

	//bZ[W[v
	while( GetMessage(&msg,NULL,0,0) )
	{
		if( IsDialogMessage(hDlg,&msg) == FALSE )
		{
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
	}

	return	msg.wParam;
}

//P擾
LPTSTR GetArc( LPTSTR szCmd, LPTSTR szArc )
{
	TCHAR	*pCmd=szCmd;
	TCHAR	*pArc=szArc;

	if( *pCmd=='\"' )
	{
		pCmd++;
		while( *pCmd && *pCmd!='\"' )
			*(pArc++) = *(pCmd++);
		*pArc=0;
		pCmd++;
	}
	else
	{
		while( *pCmd && *pCmd!=' ' && *pCmd!='\t' )
			*(pArc++) = *(pCmd++);
		*pArc=0;
	}
	while( *pCmd && (*pCmd==' ' || *pCmd=='\t') )
		pCmd++;

	return	pCmd;
}

//C֐
int WINAPI WinMain( HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLineA, int nCmdShow )
{
	LPTSTR	lpCmdLine;
	TCHAR	szFile[MAX_PATH];

	ArcDllInit();

	//邩
	lpCmdLine = GetArc( GetCommandLine(), szFile );
	if( lstrlen(lpCmdLine) == 0 )	//_CAO
	{
		OptionDialog( hInst, nCmdShow );
	}
	else								//
	{
		while( *lpCmdLine )
		{
			lpCmdLine = GetArc( lpCmdLine, szFile );
			ExtractFile( szFile );
		}
	}

	ArcDllExit();

	return	0;
}
//
void __cdecl WinMainCRTStartup( void )
{
	ExitProcess( WinMain( GetModuleHandle(NULL), NULL, NULL, SW_SHOWDEFAULT ) );
}
